
--Cration de la base avec Mthodes

CREATE TYPE telephone_elt_vry_type AS OBJECT
 (numTel VARCHAR2(14))
/
CREATE TYPE telephone_vry_type AS VARRAY(3) OF telephone_elt_vry_type
/
CREATE TYPE client_type AS OBJECT
 (num NUMBER(5), nom VARCHAR2(30), adresse VARCHAR2(30), 
  telephone_vry telephone_vry_type,
  MEMBER FUNCTION nbCepargne RETURN NUMBER,
  MEMBER PROCEDURE supprimeTel(indice In NUMBER),
  MEMBER PROCEDURE afficheInterets)
/

CREATE TYPE compte_type AS OBJECT
 (nCompte VARCHAR2(5), solde NUMBER(10,2), dateOuv DATE, ref_Client REF client_type,
  STATIC PROCEDURE fermeCompte (cpt IN VARCHAR2) )
 NOT FINAL NOT INSTANTIABLE
/

CREATE TYPE signataire_elt_nt_type AS OBJECT
 (num NUMBER(5), droit CHAR(1))
/
CREATE TYPE signataire_nt_type AS TABLE OF signataire_elt_nt_type
/
CREATE TYPE cptCourant_type UNDER compte_type 
 (nbOpCB NUMBER(5), signataire_nt signataire_nt_type,
  MEMBER FUNCTION  nbSignataire RETURN NUMBER,
  MEMBER FUNCTION  nbSignataire (droitparam IN CHAR) RETURN NUMBER,
  MEMBER FUNCTION estTitulaire(cli IN NUMBER) RETURN BOOLEAN,
  MEMBER FUNCTION estSignataire(cli IN NUMBER, droitparam IN CHAR) RETURN BOOLEAN,
  MEMBER PROCEDURE supprimeSign (nclient IN NUMBER),
  MEMBER PROCEDURE passeMvt     (cli IN NUMBER, somme IN NUMBER))
/
CREATE TYPE cptEpargne_type UNDER compte_type 
 (txInt NUMBER(2,1),
  MEMBER FUNCTION calculeInterets RETURN NUMBER)
/
CREATE TYPE mouvement_type AS OBJECT
 (ref_Client REF client_type, ref_CptCourant REF cptCourant_type,
  dateOp DATE, montant NUMBER(8,2))
/

CREATE TABLE Client OF client_type
  (CONSTRAINT pk_client PRIMARY KEY (num));

CREATE TABLE CptCourant OF cptCourant_type 
  (CONSTRAINT pk_cptCourant         PRIMARY KEY (nCompte),
   CONSTRAINT nn_Courant_ref_Client CHECK (ref_Client IS NOT NULL),
   CONSTRAINT refer_Courant_Client  ref_Client REFERENCES Client)
   NESTED TABLE signataire_nt STORE AS signataire_tabnt;

ALTER TABLE signataire_tabnt
	ADD CONSTRAINT ck_droit CHECK (droit IN ('X','R','D'));

ALTER TABLE signataire_tabnt
	ADD CONSTRAINT nn_signataire_num CHECK (num IS NOT NULL);

ALTER TABLE signataire_tabnt
	ADD CONSTRAINT nn_signataire_droit CHECK (droit IS NOT NULL);

CREATE TABLE CptEpargne OF cptEpargne_type 
  (CONSTRAINT pk_cptEpargne PRIMARY KEY (nCompte),
   CONSTRAINT nn_Epargne_ref_Client CHECK (ref_Client IS NOT NULL),
   CONSTRAINT refer_Epargne_Client  ref_Client REFERENCES Client,
   CONSTRAINT ck_txInt              CHECK (txInt < 3.5));

CREATE TABLE Mouvement OF mouvement_type
  (CONSTRAINT refer_Mvt_Client      ref_Client REFERENCES Client,
   CONSTRAINT nn_Mvt_ref_Client     CHECK (ref_Client IS NOT NULL),
   CONSTRAINT refer_Mvt_CptCourant  ref_CptCourant REFERENCES CptCourant,
   CONSTRAINT nn_Mvt_ref_CptCourant CHECK (ref_CptCourant IS NOT NULL),
   CONSTRAINT df_dateOp     dateOp  DEFAULT (SYSDATE-2) );  


