----------------------------------
-- TP2 : Insertion dans la base --
----------------------------------

DELETE FROM Mouvement;
DELETE FROM CptEpargne;
DELETE FROM CptCourant;
DELETE FROM Client;


--Insertion des clients

INSERT INTO Client VALUES
  (client_type(1, 'Albaric', 'Pont Vieux  - Vielle Toulouse',
            telephone_vry_type(telephone_elt_vry_type('05-61-75-68-39'), 
                               telephone_elt_vry_type(NULL)) ));

INSERT INTO Client VALUES
  (client_type(2, 'Bidal', 'Port Royal - Paris',
            telephone_vry_type(telephone_elt_vry_type(NULL), 
                               telephone_elt_vry_type(NULL),
                               telephone_elt_vry_type('06-76-85-14-89'))));

INSERT INTO Client VALUES
  (client_type(3, 'Miranda', 'Antipolis - Nice',
            telephone_vry_type(telephone_elt_vry_type(NULL), 
                               telephone_elt_vry_type('04-35-60-77-89'),
                               telephone_elt_vry_type('06-81-94-44-31'))));

INSERT INTO Client VALUES
  (client_type(4, 'Payrissat', 'Salas - Ramonville St Agne',
            telephone_vry_type(telephone_elt_vry_type('05-61-75-98-44'), 
                               telephone_elt_vry_type(NULL),
                               telephone_elt_vry_type('06-46-45-72-30'))));

INSERT INTO Client VALUES
  (client_type(5, 'Vielle', 'INRA - Auzeville Tolosane',
            telephone_vry_type(telephone_elt_vry_type('05-61-73-12-74'), 
                               telephone_elt_vry_type('05-62-74-75-63'),
                               telephone_elt_vry_type('06-65-41-83-35'))));

--Insertion des comptes

INSERT INTO CptCourant VALUES
	(cptCourant_type('CC1', 4030, '01-02-2001',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 1), 509,
	 signataire_nt_type()) 
	);

INSERT INTO CptCourant VALUES
	(cptCourant_type('CC2', 3000, '15-02-2002',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 1), 0,
	 signataire_nt_type()) 
	);

INSERT INTO CptCourant VALUES
	(cptCourant_type('CC3', 460, '13-05-2000',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 4), 678,
	 signataire_nt_type()) 
	);

INSERT INTO CptCourant VALUES
	(cptCourant_type('CC4', 730, '17-09-2002',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 4), 0,
	 signataire_nt_type()) 
	);

INSERT INTO CptCourant VALUES
	(cptCourant_type('CC5', 15, '10-12-1998',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 4), 1390,
	 signataire_nt_type()) 
	);

INSERT INTO CptCourant VALUES
	(cptCourant_type('CC6', 55, '16-01-1965',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 2), 2400,
	 signataire_nt_type()) 
	);

INSERT INTO CptCourant VALUES
	(cptCourant_type('CC7', 6700, '04-03-1976',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 3), 5600,
	 signataire_nt_type()) 
	);

--Signataires

INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC2') 
	VALUES (signataire_elt_nt_type(2,'D'));
INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC2') 
	VALUES (signataire_elt_nt_type(2,'R'));
INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC2') 
	VALUES (signataire_elt_nt_type(3,'R'));


INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC3') 
	VALUES (signataire_elt_nt_type(1,'D'));
INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC3') 
	VALUES (signataire_elt_nt_type(5,'D'));


INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC6') 
	VALUES (signataire_elt_nt_type(3,'D'));


INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') 
	VALUES (signataire_elt_nt_type(2,'D'));
INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') 
	VALUES (signataire_elt_nt_type(2,'R'));
INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') 
	VALUES (signataire_elt_nt_type(2,'X'));
INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') 
	VALUES (signataire_elt_nt_type(1,'D'));
INSERT INTO TABLE 
	(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') 
	VALUES (signataire_elt_nt_type(5,'D'));

--Epargne


INSERT INTO CptEpargne VALUES
	(cptEpargne_type('CE1', 600, '05-02-1965',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 2), 2.7 ));
INSERT INTO CptEpargne VALUES
	(cptEpargne_type('CE2', 4500, '04-12-1998',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 2), 2.9 ));


INSERT INTO CptEpargne VALUES
	(cptEpargne_type('CE3', 500, '05-03-2000',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 4), 2.9 ));
INSERT INTO CptEpargne VALUES
	(cptEpargne_type('CE4', 500, '05-02-2001',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 4), 2.4 ));
INSERT INTO CptEpargne VALUES
	(cptEpargne_type('CE5', 500, '13-05-1995',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 4), 3.4 ));

INSERT INTO CptEpargne VALUES
	(cptEpargne_type('CE6', 3300, '23-08-1997',
	 (SELECT REF(cli) FROM Client cli WHERE cli.num = 3), 3.3 ));


--Insertion de mouvements Cpt courant

--cpt Albaric pas de signataire sur CC1
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 1),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC1'),
	SYSDATE-7, 100)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 1),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC1'),
	SYSDATE-7, -65)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 1),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC1'),
	SYSDATE-5, 40)  );

--cpt Albaric CC2 signataire 2,D
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 2),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC1'),
	SYSDATE-5, -80)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 2),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC1'),
	SYSDATE-3, -50)  );


--cpt Bidal un signataire 3,D
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 2),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC6'),
	 SYSDATE-7, 30)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 2),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC6'),
	SYSDATE-7, -15)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 3),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC6'),
	SYSDATE-5, -20)  );


--cpt Miranda 3 signataire 2-DRX, 1-D, 5-D
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 3),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC7'),
	 SYSDATE-7, 300)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 3),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC7'),
	SYSDATE-6, -105)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 2),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC7'),
	SYSDATE-5, -20)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 1),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC7'),
	SYSDATE-4, -10)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 5),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC7'),
	SYSDATE-5, -60)  );

--cpt Payrissat (4),  1 signataire sur CC3 1-D
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 4),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC4'),
	 SYSDATE-2, 10)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 4),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC4'),
	 SYSDATE-2, -70)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 4),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC5'),
	 SYSDATE-5, 300)  );

INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 4),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC3'),
	 SYSDATE-1, -50)  );
INSERT INTO mouvement VALUES
  (mouvement_type(
	(SELECT REF(cli) FROM Client cli     WHERE cli.num     = 1),
	(SELECT REF(cou) FROM CptCourant cou WHERE cou.nCompte = 'CC3'),
	 SYSDATE-2, -70)  );


COMMIT;