SET VERIFY OFF;
----------------------------------
-- TP2 : Selection dans la base --
----------------------------------



--1. Liste des clients sans leur numro de tlphone

SELECT c.num, c.nom, c.adresse FROM Client c;


--2. Liste des compte courants

SELECT  nCompte, solde, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", nbOpCB 
	FROM CptCourant;

--3. Listes des comptes pargne

SELECT  nCompte, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", solde, txInt 
	FROM CptEpargne;

--4. Liste des comptes courant d'un client de numro donn

COLUMN nCompte FORMAT A30 HEADING 'Comptes courants du client 4'
SELECT  cou.nCompte, cou.solde, TO_CHAR(cou.dateOuv,'DD/MM/YYYY')
	FROM CptCourant cou
	WHERE cou.ref_Client.num = 4;
CLEAR COLUMN


--5. Liste des comptes d'un client de numro donn

COLUMN  nCompte FORMAT A30 HEADING 'Comptes courants du client 4'
SELECT  cou.nCompte, cou.solde, TO_CHAR(cou.dateOuv,'DD/MM/YYYY') "DATEOUV" 
	FROM CptCourant cou
	WHERE cou.ref_Client.num = 4
UNION
SELECT  cep.nCompte, cep.solde, TO_CHAR(cep.dateOuv,'DD/MM/YYYY')
	FROM CptEpargne cep
	WHERE cep.ref_Client.num = 4;

CLEAR COLUMN

--6. Liste des clients titulaires des comptes courant ayant un solde infrieur 400
--
CLEAR COLUMN
COL  ref_Client.nom FORMAT A15 HEADING 'NOM'
SELECT  cou.ref_Client.num, cou.ref_Client.nom, cou.ref_Client.adresse, cou.nCompte, cou.solde
	FROM CptCourant cou 
	WHERE cou.solde < 400;
CLEAR COLUMN


--7. Numro et nom des clients possdant au moins un compte pargne

SELECT DISTINCT(cep.ref_Client.num), cep.ref_Client.nom, cep.ref_Client.adresse
	FROM CptEpargne cep;


--8. clients n'ayant ouvert qu'un seul compte pargne

SELECT  cep.ref_Client.num, cep.ref_Client.nom, cep.ref_Client.adresse 
	FROM CptEpargne cep 
	GROUP BY (cep.ref_Client.num, cep.ref_Client.nom, cep.ref_Client.adresse)
	HAVING count(*)=1;


--9. Pour chaque client, afficher le nombre de compte pargne qu'il possde

COLUMN  nbr HEADING 'Nombre de comptes pargne'
SELECT  cep.ref_Client.num, cep.ref_Client.nom, COUNT(*) nbr 
	FROM  CptEpargne cep
	GROUP BY (cep.ref_Client.num, cep.ref_Client.nom);



--10. Mme requte pour afficher aussi les clients n'ayant pas de compte pargne

COLUMN  nbr HEADING 'Nombre de comptes pargne'
SELECT  cep.ref_Client.num, cep.ref_Client.nom, COUNT(*) nbr 
	FROM  CptEpargne cep
	GROUP BY (cep.ref_Client.num, cep.ref_Client.nom)
UNION
SELECT  num, nom, 0 
	FROM client
	WHERE num NOT IN (SELECT DISTINCT cep.ref_Client.num FROM  CptEpargne cep);

--11. Nom du titulaire ayant le plus de comptes pargne

SELECT cep.ref_Client.num, cep.ref_Client.nom, COUNT(*) "Nombre"
	FROM     CptEpargne cep 
	GROUP BY (cep.ref_Client.num, cep.ref_Client.nom)
	HAVING   COUNT(*) = (SELECT MAX(COUNT(*)) FROM CptEpargne cep2 
			     GROUP BY (cep2.ref_Client.num, cep2.ref_Client.nom));

--12. Liste des clients qui ont fait des oprations sur un compte courant pour un numro donn

SELECT m.ref_Client.num, m.ref_Client.nom, m.dateOp, m.montant 
	FROM Mouvement m 
	WHERE m.ref_CptCourant.nCompte = 'CC7';


--13. Liste des oprations qui ont t faites par un client propritaire du compte modifi

SELECT m.ref_Client.num, m.ref_Client.nom, m.dateOp, m.montant 
	FROM Mouvement m 
	WHERE m.ref_CptCourant.nCompte        = 'CC7'
	AND   m.ref_CptCourant.ref_Client.num = m.ref_Client.num;

--14. Liste des oprations qui ont t faites par les non propritaires du compte modifi

SELECT m.ref_Client.num, m.ref_Client.nom, m.dateOp, m.montant 
	FROM Mouvement m 
	WHERE m.ref_CptCourant.nCompte          = 'CC7'
	AND NOT(m.ref_CptCourant.ref_Client.num = m.ref_Client.num);

--15. Nombre de tlphone d'un numero de client donn

SELECT COUNT(*) "Taille telephone_vry, client 1"
	FROM TABLE(SELECT telephone_vry FROM Client WHERE num = 1);

SELECT COUNT(numTel) "Nombre Tlphones, client 1"
	FROM TABLE(SELECT telephone_vry FROM Client WHERE num = 1);

--16
SELECT  c.num, COUNT(avry.numTel) "Nombre Tlphones"
	FROM Client c, TABLE(c.telephone_vry) avry
	GROUP BY  c.num;


--17 Nombre de signataires d'un compte courant du numro donn

SELECT  COUNT(*) "Nombre de signataires CC7" FROM 
	TABLE(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7');

--18
SELECT  cou.nCompte, COUNT(DISTINCT(ant.num)) "Nombre de signataires"
	FROM CptCourant cou, TABLE(cou.signataire_nt) ant
	GROUP BY cou.nCompte;

--19. Numro de tlphone d'un client donn

SELECT avry.numTel 
	FROM TABLE(SELECT telephone_vry FROM Client WHERE num = 1) avry;

--20
--ts les clients ====> affichage ne respecte pas les indices !!!!
SELECT  c.num, avry.numTel
	FROM Client c, TABLE(c.telephone_vry) avry
	ORDER BY 1,2;

--21. Numros et droits des signataires d'un compte courant donn
COL droit FORMAT A5
SELECT  ant.num "Signataires CC7", ant.droit FROM 
	TABLE(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') ant;

--22 Mme requete, ts comptes
SELECT  cou.nCompte, ant.num "SIGNATAIRE", ant.droit
	FROM CptCourant cou, TABLE(cou.signataire_nt) ant
	ORDER BY 1,2;

--23. Numros et droits des signataires pour tous les comptes courants

SELECT cou.nCompte, CURSOR(SELECT ant.num "SIGNATAIRE", ant.droit 
			   FROM TABLE(signataire_nt) ant ) 
	FROM CptCourant cou;

--24. Numros et adresses des signataires d'un compte courant donn

SELECT ant.num "Signataires CC7", cli.adresse "ADRESSE", ant.droit 
	FROM TABLE(SELECT signataire_nt 
		   FROM CptCourant WHERE nCompte = 'CC7') ant, Client cli
	WHERE cli.num = ant.num;
