SET VERIFY OFF;
SET SERVEROUT ON;

--nbCepargne() 
SELECT cli.num, cli.nbCepargne() 
	FROM Client cli;
--
DECLARE
  un_Client client_type;
BEGIN
  SELECT VALUE(cli) INTO un_Client
	FROM Client cli WHERE cli.num = 4;
  DBMS_OUTPUT.PUT_LINE('Le client numro 4 possde '|| un_Client .nbCepargne()
	|| ' compte(s) pargne(s)');
END;
/

--nbSignataire() 
SELECT  cou.nCompte, cou.nbSignataire() 
	FROM cptCourant cou;

--Test de la mthode par un bloc PL/SQL
DECLARE
  unCptCourant cptCourant_type;
  resultat NUMBER;
BEGIN
  SELECT VALUE(cou) INTO unCptCourant
	FROM cptCourant cou WHERE cou.nCompte = 'CC7';
	resultat := unCptCourant.nbSignataire();
	DBMS_OUTPUT.PUT_LINE('Le compte courant CC7 a '|| resultat || ' signataire(s)');
END;
/


--nbSignataire('X'),
clear col
SELECT  cou.nCompte, cou.nbSignataire('X'), cou.nbSignataire('R'), cou.nbSignataire('D')
	FROM cptCourant cou;


--calculeInterets()
SELECT ncompte, solde, txInt FROM cptEpargne;

DECLARE
  unCompteEpargne cptEpargne_type;
BEGIN
  SELECT VALUE(cep) INTO unCompteEpargne
	FROM cptEpargne cep
	WHERE cep.nCompte = 'CE5';
  DBMS_OUTPUT.PUT_LINE('Epargne cumule de CE5 : ' || unCompteEpargne.calculeInterets());  
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('CE5, compte pargne inexistant');
END;
/



--estTitulaire(cli)
DECLARE
  unCptCourant cptCourant_type;
BEGIN
  SELECT VALUE(cou) INTO unCptCourant
	FROM cptCourant cou WHERE cou.nCompte = 'CC4';
  IF ( unCptCourant.estTitulaire(4) ) THEN
	DBMS_OUTPUT.PUT_LINE('Le client 4 est titulaire du compte CC4');
  ELSE
	DBMS_OUTPUT.PUT_LINE('Le client 4 n''est pas titulaire du compte CC4');	
  END IF;
  IF ( unCptCourant.estTitulaire(5) ) THEN
	DBMS_OUTPUT.PUT_LINE('Le client 5 est titulaire du compte CC4');
  ELSE
	DBMS_OUTPUT.PUT_LINE('Le client 5 n''est pas titulaire du compte CC4');	
  END IF;
END;
/
--
DECLARE
  unCptCourant cptCourant_type;
BEGIN
  SELECT VALUE(cou) INTO unCptCourant
	FROM cptCourant cou WHERE cou.nCompte = 'CC7';
   IF ( unCptCourant.estSignataire(5,'D') ) THEN
	DBMS_OUTPUT.PUT_LINE('Le client 5 est signataire (D) pour le compte CC7');
  ELSE
	DBMS_OUTPUT.PUT_LINE('Le client 5 n''est pas signataire (D) pour le compte CC7');	
  END IF;
  IF ( unCptCourant.estSignataire(3,'D') ) THEN
	DBMS_OUTPUT.PUT_LINE('Le client 3 est signataire (D) pour le compte CC7');
  ELSE
	DBMS_OUTPUT.PUT_LINE('Le client 3 n''est pas signataire (D) pour le compte CC7');	
  END IF;
END;
/



-- supprimeTel();

commit;
SELECT avry.numTel 
	FROM TABLE(SELECT telephone_vry FROM Client WHERE num = 4) avry;
DECLARE
  unClient  client_type;
BEGIN
  SELECT VALUE(cli) INTO unClient 
	FROM client cli	WHERE cli.num = 4;
  unClient.supprimeTel(2);
  unClient.supprimeTel(3);
EXCEPTION
  WHEN NO_DATA_FOUND THEN
    DBMS_OUTPUT.PUT_LINE('Client inexistant');
END;
/
SELECT avry.numTel 
	FROM TABLE(SELECT telephone_vry FROM Client WHERE num = 4) avry;
rollback;
SELECT avry.numTel 
	FROM TABLE(SELECT telephone_vry FROM Client WHERE num = 4) avry;



--supprimeSign(2);  
COL droit FORMAT A5
SELECT  ant.num "Signataires CC7", ant.droit FROM 
	TABLE(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') ant;
commit;

DECLARE
 unCptCourant cptCourant_type;
BEGIN
  SELECT VALUE(cou) INTO unCptCourant
	FROM cptCourant cou WHERE cou.nCompte = 'CC7';	
  unCptCourant.supprimeSign(2);  
  unCptCourant.supprimeSign(6);  
END;
/

SELECT  ant.num "Signataires CC7", ant.droit FROM 
	TABLE(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') ant;
rollback;
SELECT  ant.num "Signataires CC7", ant.droit FROM 
	TABLE(SELECT signataire_nt FROM CptCourant WHERE nCompte = 'CC7') ant;


--afficheinterets
DECLARE
  unClient client_type;
BEGIN
  SELECT VALUE(cli) INTO unClient FROM Client cli WHERE cli.num= 4;
  unClient.afficheInterets();
END;
/

--fermeCompte
SELECT  nCompte, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", solde, txInt 
	FROM CptEpargne;
SELECT  nCompte, solde, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", nbOpCB 
	FROM CptCourant;
SELECT m.ref_Client.num, m.ref_CptCourant.nCompte, m.dateOp, m.montant 
	FROM Mouvement m;
commit;

BEGIN
	CptEpargne_type.fermeCompte('CE4');
	CptEpargne_type.fermeCompte('CE?');
	CptCourant_type.fermeCompte('CC1');
	CptCourant_type.fermeCompte('CC?');
END;
/

SELECT  nCompte, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", solde, txInt 
	FROM CptEpargne;
SELECT  nCompte, solde, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", nbOpCB 
	FROM CptCourant;
SELECT m.ref_Client.num, m.ref_CptCourant.nCompte, m.dateOp, m.montant 
	FROM Mouvement m;
rollback;

--passeMvt
DELETE FROM Mouvement;
UPDATE cptCourant SET solde = 0;

SELECT  nCompte, solde, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", nbOpCB 
	FROM CptCourant;
SELECT m.ref_Client.num, m.ref_CptCourant.nCompte, m.dateOp, m.montant 
	FROM Mouvement m;

DECLARE
 unCptCourant cptCourant_type;
BEGIN
  SELECT VALUE(cou) INTO unCptCourant
	FROM cptCourant cou WHERE cou.nCompte = 'CC3';
  --titulaire	
  unCptCourant.passeMvt(4,50);
  unCptCourant.passeMvt(4,-10);
  --signataire droit D
  unCptCourant.passeMvt(1,10);
  unCptCourant.passeMvt(1,-5);
  --non signataire
  unCptCourant.passeMvt(3,5);
  unCptCourant.passeMvt(3,-10);
END;
/
SELECT  nCompte, solde, TO_CHAR(dateOuv,'DD/MM/YYYY') "DATEOUV", nbOpCB 
	FROM CptCourant;
SELECT m.ref_Client.num, m.ref_CptCourant.nCompte, m.dateOp, m.montant 
	FROM Mouvement m;
rollback;





