
--38

ALTER TYPE client_type 
 ADD ATTRIBUTE ref_ParrainClient REF client_type CASCADE;

UPDATE Client c
   SET c.ref_ParrainClient = (SELECT REF(c) FROM Client c WHERE c.nom = 'Albaric')
   WHERE c.nom = 'Bidal' OR c.nom = 'Miranda';

UPDATE Client c
   SET c.ref_ParrainClient = (SELECT REF(c) FROM Client c WHERE c.nom = 'Miranda')
   WHERE c.nom = 'Payrissat';

COMMIT;

SELECT c.num, c.nom, c.ref_ParrainClient.nom FROM Client c;

SELECT c.num, c.nom, c.ref_ParrainClient.ref_ParrainClient.nom "Parrain du parrain"
  FROM Client c
  WHERE c.ref_ParrainClient.ref_ParrainClient IS NOT NULL;

--39

CREATE TYPE produits_vendus_elt_nt_type AS OBJECT
 (nomProd VARCHAR2(10), valeur NUMBER(7,2))
/
CREATE TYPE produits_vendus_nt_type AS TABLE OF produits_vendus_elt_nt_type 
/
CREATE TYPE rendez_vous_elt_vry_type AS OBJECT 
 (conseiller VARCHAR2(15), mois VARCHAR2(20), produits_vendus_nt produits_vendus_nt_type)
/
CREATE TYPE rendez_vous_vry_type AS VARRAY(12) OF rendez_vous_elt_vry_type 
/

CREATE TABLE Statistiques
 (num NUMBER(5) PRIMARY KEY, rendez_vous_vry rendez_vous_vry_type)
  VARRAY rendez_vous_vry STORE AS LOB tabqualifs_LOB
  (ENABLE STORAGE in ROW STORAGE 
     (INITIAL 100K NEXT 100K MINEXTENTS 2 MAXEXTENTS 5 PCTINCREASE 10));


INSERT INTO Statistiques
 VALUES (1,rendez_vous_vry_type(
            rendez_vous_elt_vry_type('Filou','Janvier 2004',
              produits_vendus_nt_type (
                produits_vendus_elt_nt_type ('PEL',150),
                produits_vendus_elt_nt_type ('CEL',500))),
            rendez_vous_elt_vry_type('Screau','Avril 2004',
              produits_vendus_nt_type (
                produits_vendus_elt_nt_type ('CODEVI',400))),
            rendez_vous_elt_vry_type('Manteur','Mai 2004',
              produits_vendus_nt_type (
                produits_vendus_elt_nt_type ('SICAV_A',700),
                produits_vendus_elt_nt_type ('ACTIONS_B',400))),
            rendez_vous_elt_vry_type('Screau','Aout 2004',
              produits_vendus_nt_type (
                produits_vendus_elt_nt_type ('EPARVIE',300))) ));
   

SELECT s.num, r.conseiller, r.mois, p.nomProd, p.valeur
  FROM Statistiques s, TABLE(s.rendez_vous_vry) r, TABLE(r.produits_vendus_nt) p;

--ajout d'un rdv
set serverout on
DECLARE
   tableau_rdv rendez_vous_vry_type;
BEGIN	
   SELECT rendez_vous_vry INTO tableau_rdv FROM Statistiques WHERE num = 1
     FOR UPDATE OF rendez_vous_vry ; 
 dbms_output.put_line(tableau_rdv.COUNT);
  IF tableau_rdv.COUNT < 12 THEN
      tableau_rdv.EXTEND;
 dbms_output.put_line(tableau_rdv.LAST);
      tableau_rdv(tableau_rdv.LAST) :=
          rendez_vous_elt_vry_type('Larnac','Septembre 2004',produits_vendus_nt_type());
       UPDATE Statistiques SET rendez_vous_vry = tableau_rdv WHERE num = 1;
   END IF;
END;
/

--ajout d'un produit au rdv prcdemment ajout

DECLARE
 tableau_rdv rendez_vous_vry_type;
 tableau_prod produits_vendus_nt_type;
BEGIN
   SELECT rendez_vous_vry INTO tableau_rdv FROM Statistiques WHERE num = 1
     FOR UPDATE OF rendez_vous_vry ;
   SELECT produits_vendus_nt INTO tableau_prod FROM TABLE 
     (SELECT rendez_vous_vry FROM Statistiques WHERE num = 1) 
        WHERE conseiller = 'Larnac' AND mois ='Septembre 2004';
--
-- Insertion dans la nested table contenue dans le varray
--
   tableau_prod.EXTEND;
   tableau_prod (tableau_prod.LAST) := produits_vendus_elt_nt_type('LIVRET-A',800);  
   tableau_rdv(tableau_rdv.LAST).produits_vendus_nt  :=tableau_prod  ;
--
   UPDATE Statistiques SET rendez_vous_vry = tableau_rdv WHERE num = 1;
END;
/

SELECT s.num, r.conseiller, r.mois, p.nomProd, p.valeur
  FROM Statistiques s, TABLE(s.rendez_vous_vry) r, TABLE(r.produits_vendus_nt) p;

SELECT r.conseiller, SUM(p.valeur)
  FROM Statistiques s, TABLE(s.rendez_vous_vry) r, TABLE(r.produits_vendus_nt) p
  GROUP BY r.conseiller ORDER BY 2 DESC;

